using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Bus_AppealInfo
    /// </summary>
    public partial class T_Bus_AppealInfo
    {
        public T_Bus_AppealInfo()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Bus_AppealInfo");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Bus_AppealInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Bus_AppealInfo(");
            strSql.Append("F_WorkOrderId,F_Title,F_Content,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DeptIds,F_NoticeID,F_NoticeInfo,F_SureTime,F_NCId,F_Files,F_Basis,F_Requirement,F_Type,F_TypeID,F_Reason)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderId,@F_Title,@F_Content,@F_Remark,@F_State,@F_CreateUser,@F_CreateTime,@F_IsDelete,@F_DeleteUser,@F_DeleteTime,@F_DeptIds,@F_NoticeID,@F_NoticeInfo,@F_SureTime,@F_NCId,@F_Files,@F_Basis,@F_Requirement,@F_Type,@F_TypeID,@F_Reason)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DeptIds", SqlDbType.VarChar,500),
            new SqlParameter("@F_NoticeID", SqlDbType.Int,4),
            new SqlParameter("@F_NoticeInfo", SqlDbType.VarChar,500),
            new SqlParameter("@F_SureTime", SqlDbType.DateTime),
            new SqlParameter("@F_NCId", SqlDbType.Int,4),
            new SqlParameter("@F_Files", SqlDbType.VarChar,500),
            new SqlParameter("@F_Basis", SqlDbType.VarChar,500),
            new SqlParameter("@F_Requirement", SqlDbType.VarChar,500),
            new SqlParameter("@F_Type", SqlDbType.VarChar,50),
            new SqlParameter("@F_TypeID", SqlDbType.Int,4),
            new SqlParameter("@F_Reason", SqlDbType.NVarChar,-1)
            };
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_Title;
            parameters[2].Value = model.F_Content;
            parameters[3].Value = model.F_Remark;
            parameters[4].Value = model.F_State;
            parameters[5].Value = model.F_CreateUser;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_IsDelete;
            parameters[8].Value = model.F_DeleteUser;
            parameters[9].Value = model.F_DeleteTime;
            parameters[10].Value = model.F_DeptIds;
            parameters[11].Value = model.F_NoticeID;
            parameters[12].Value = model.F_NoticeInfo;
            parameters[13].Value = model.F_SureTime;
            parameters[14].Value = model.F_NCId;
            parameters[15].Value = model.F_Files;
            parameters[16].Value = model.F_Basis;
            parameters[17].Value = model.F_Requirement;
            parameters[18].Value = model.F_Type;
            parameters[19].Value = model.F_TypeID;
            parameters[20].Value = model.F_Reason;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Bus_AppealInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Bus_AppealInfo set ");
            strSql.Append("F_WorkOrderId=@F_WorkOrderId,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_DeleteUser=@F_DeleteUser,");
            strSql.Append("F_DeleteTime=@F_DeleteTime,");
            strSql.Append("F_DeptIds=@F_DeptIds,");
            strSql.Append("F_NoticeID=@F_NoticeID,");
            strSql.Append("F_NoticeInfo=@F_NoticeInfo,"); 
                strSql.Append("F_SureTime=@F_SureTime,"); 
                strSql.Append("F_NCId=@F_NCId,");
            strSql.Append("F_Files=@F_Files,");
            strSql.Append("F_Basis=@F_Basis,");
            strSql.Append("F_Requirement=@F_Requirement,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_TypeID=@F_TypeID,");
            strSql.Append("F_Reason=@F_Reason");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DeptIds", SqlDbType.VarChar,500),
                    new SqlParameter("@F_Id", SqlDbType.Int,4),
            new SqlParameter("@F_NoticeID", SqlDbType.Int,4),
            new SqlParameter("@F_NoticeInfo", SqlDbType.VarChar,500),
            new SqlParameter("@F_SureTime", SqlDbType.DateTime),
            new SqlParameter("@F_NCId", SqlDbType.Int,4),
            new SqlParameter("@F_Files", SqlDbType.VarChar,500),
            new SqlParameter("@F_Basis", SqlDbType.VarChar,500),
            new SqlParameter("@F_Requirement", SqlDbType.VarChar,500),
            new SqlParameter("@F_Type", SqlDbType.VarChar,50),
            new SqlParameter("@F_TypeID", SqlDbType.Int,4),
            new SqlParameter("@F_Reason", SqlDbType.NVarChar,-1)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_Title;
            parameters[2].Value = model.F_Content;
            parameters[3].Value = model.F_Remark;
            parameters[4].Value = model.F_State;
            parameters[5].Value = model.F_CreateUser;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_IsDelete;
            parameters[8].Value = model.F_DeleteUser;
            parameters[9].Value = model.F_DeleteTime;
            parameters[10].Value = model.F_DeptIds;
            parameters[11].Value = model.F_Id;
            parameters[12].Value = model.F_NoticeID;
            parameters[13].Value = model.F_NoticeInfo;
            parameters[14].Value = model.F_SureTime;
            parameters[15].Value = model.F_NCId;
            parameters[16].Value = model.F_Files;
            parameters[17].Value = model.F_Basis;
            parameters[18].Value = model.F_Requirement;
            parameters[19].Value = model.F_Type;
            parameters[20].Value = model.F_TypeID;
            parameters[21].Value = model.F_Reason;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_AppealInfo ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_AppealInfo ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_AppealInfo GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_WorkOrderId,F_Title,F_Content,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DeptIds,F_NoticeID,F_NoticeInfo,F_SureTime,F_NCId,F_Files,F_Basis,F_Requirement,F_Type,F_TypeID,F_Reason from T_Bus_AppealInfo WITH(NOLOCK) ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Bus_AppealInfo model = new CallCenterApi.Model.T_Bus_AppealInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_AppealInfo DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Bus_AppealInfo model = new CallCenterApi.Model.T_Bus_AppealInfo();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_DeleteUser"] != null)
                {
                    model.F_DeleteUser = row["F_DeleteUser"].ToString();
                }
                if (row["F_DeleteTime"] != null && row["F_DeleteTime"].ToString() != "")
                {
                    model.F_DeleteTime = DateTime.Parse(row["F_DeleteTime"].ToString());
                }
                if (row["F_DeptIds"] != null)
                {
                    model.F_DeptIds = row["F_DeptIds"].ToString();
                }
                if (row["F_NoticeID"] != null && row["F_NoticeID"].ToString() != "")
                {
                    model.F_NoticeID = int.Parse(row["F_NoticeID"].ToString());
                }
                if (row["F_NoticeInfo"] != null)
                {
                    model.F_NoticeInfo = row["F_NoticeInfo"].ToString();
                }
                
                if (row["F_SureTime"] != null && row["F_SureTime"].ToString() != "")
                {
                    model.F_SureTime = DateTime.Parse(row["F_SureTime"].ToString());
                }
                if (row["F_NCId"] != null && row["F_NCId"].ToString() != "")
                {
                    model.F_NCId = int.Parse(row["F_NCId"].ToString());
                }
                
                if (row["F_Files"] != null)
                {
                    model.F_Files = row["F_Files"].ToString();
                }
                if (row["F_Basis"] != null)
                {
                    model.F_Basis = row["F_Basis"].ToString();
                }
                if (row["F_Requirement"] != null)
                {
                    model.F_Requirement = row["F_Requirement"].ToString();
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_TypeID"] != null && row["F_TypeID"].ToString() != "")
                {
                    model.F_TypeID = int.Parse(row["F_TypeID"].ToString());
                }
                if (row["F_Reason"] != null)
                {
                    model.F_Reason = row["F_Reason"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_WorkOrderId,F_Title,F_Content,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DeptIds,F_NoticeID,F_NoticeInfo,F_SureTime,F_Files,F_Basis,F_Requirement,F_Type,F_TypeID,F_Reason ");
            strSql.Append(" FROM T_Bus_AppealInfo WITH(NOLOCK) ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_WorkOrderId,F_Title,F_Content,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DeptIds,F_NoticeID,F_NoticeInfo,F_SureTime,F_Files,F_Basis,F_Requirement,F_Type,F_TypeID,F_Reason ");
            strSql.Append(" FROM T_Bus_AppealInfo WITH(NOLOCK) ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Bus_AppealInfo WITH(NOLOCK) ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Bus_AppealInfo T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 得到一个对象表
        /// </summary>
        public DataTable  GetTB(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_WorkOrderId,F_Title,F_Content,F_Remark,F_State,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime,F_DeptIds,F_NoticeID,F_NoticeInfo,F_SureTime,F_NCId,F_Files,F_Basis,F_Requirement,F_Type,F_TypeID,F_Reason from T_Bus_AppealInfo WITH(NOLOCK) ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Bus_AppealInfo model = new CallCenterApi.Model.T_Bus_AppealInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return ds.Tables[0];
            }
            else
            {
                return null;
            }
        }
        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}